# Quality Assurance Settings for museum-digital

Most of the code used at [[https://www.museum-digital.org][museum-digital]] is written in PHP. To keep a uniform code style throughout the code, we use [[https://github.com/squizlabs/PHP_CodeSniffer][PHP Code Sniffer]].

## Tools used

- [[https://github.com/squizlabs/PHP_CodeSniffer][php-codesniffer]]
- [[https://github.com/phpstan/phpstan][PHPStan - PHP Static Analysis Tool]]
- [[https://phpunit.de/][phpunit]]

## This Repository

This repository serves to collect generally applicable rules, that can be embedded into the specific rule sets of the different projects.

The file `[md_phpcs_rules.xml](./rules/md_phpcs_rules.xml)` contains the main style guide. When rewriting files to fit the uniform style rules, ``[md_phpcs_rules_basic.xml](./rules/md_phpcs_rules_basic.xml)`` comes in handy as a first step. It contains the same rules, excluding some which require or encourage a more in-depth look at the code (the prohibition of procedural-style calls to mysqli functions is e.g. a good opportunity to check the efficiency of queries).

## License

This project is licensed under the MIT License. See the [LICENSE](./LICENSE) file for the full license text.
